#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "ApplicationIo.h"
#include <string>

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();


    // Setter/Getters
    void  Status(const std::string & txt);
    void  Clock(const std::string & txt);
    void  Revision(const std::string & txt);

    // Data
    IUserInterface *          UI;
    ApplicationIo *           Io;
    QStatusBar *              RevisionBar;

    // Methods
    void  Log(const std::string & a_string);
    void  OnProgress(int percent);
    void  OnLoadMessage(const std::string & Message);
    void  OnLoadComplete(unsigned int result);

    void  GetSettings();
    void  SetSettings();
    void  EnableControls();


protected:
    void changeEvent(QEvent *e);

private:
    Ui::MainWindow *ui;

private slots:
    void on_BrowseFileButton_clicked();
    void on_LoadButton_clicked();
    void on_CloseButton_clicked();
    void on_OpenButton_clicked();
};

#endif // MAINWINDOW_H
