#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "ApplicationIo.h"
#include <string>

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

    IUserInterface *          UI;
    ApplicationIo *           Io;

    // Methods
    void  Log(const std::string & a_string);
    void  OnProgress(int percent);
    void  OnParseComplete();
    void  OnLoadError(const std::string & a_string);
    void  Revision(const std::string & a_string);
    void  OnLoadComplete();

    void    UpdateControls();
    void    GetSettings();
    void    SetSettings();


protected:
    void changeEvent(QEvent *e);

private:
    Ui::MainWindow *ui;

private slots:
    void on_LogicFileButton_clicked();
    void on_LoadButton_clicked();
    void on_CloseButton_clicked();
    void on_OpenButton_clicked();
};

#endif // MAINWINDOW_H
