// ModuleIo.h
//
// Board-specific module operations

#include "ModuleIo.h"

using namespace Innovative;
using namespace std;

//---------------------------------------------------------------------------
//  TestModeStrings() -- return vector of strings for Test Mode Listbox
//---------------------------------------------------------------------------

std::vector<std::string>  TestModeStrings()
{
    std::vector<std::string>  List;

    return List;
}

//===========================================================================
//  CLASS ModuleIo  -- Hardware Access and Application Io Class
//===========================================================================
//---------------------------------------------------------------------------
//  constructor for class ModuleIo
//---------------------------------------------------------------------------

ModuleIo::ModuleIo()
{
}

//---------------------------------------------------------------------------
//  destructor for class ModuleIo
//---------------------------------------------------------------------------

ModuleIo::~ModuleIo()
{
}

//---------------------------------------------------------------------------
//  ModuleIo::FiclConnectTo() --  Connect to FICL system
//---------------------------------------------------------------------------

void  ModuleIo::FiclConnectTo(FiclSystem & ficl)
{
    // do nothing if FICL is not supported by the board

    //  Attach board specific commands to FICL
    ficl.ConnectTarget(FiclTarget());
}

//---------------------------------------------------------------------------
//  ModuleIo::Help() --  module-specific help command
//---------------------------------------------------------------------------

std::string ModuleIo::Help() const
{
    return "cr ?system cr ?X3-SD16";
}

//---------------------------------------------------------------------------
//  ModuleIo::AfterOpen() --  Post Open Customization
//---------------------------------------------------------------------------

void  ModuleIo::AfterOpen()
{
    // Implement Only For Servo 16 -- read against Version ROM Dash info
    // Initialize fast clock setting
    //Module().FastClock(Settings.FastClock);
}

//---------------------------------------------------------------------------
//  ModuleIo::Configure() --  Configure special module features
//---------------------------------------------------------------------------

void  ModuleIo::Configure(Innovative::BinView & /*hs*/, Innovative::BinView & /*ls*/)
{
}

//---------------------------------------------------------------------------
//  ModuleIo::SetInputSoftwareTrigger() --  Set or Clear Software Trigger
//---------------------------------------------------------------------------

void  ModuleIo::SetInputSoftwareTrigger(bool state)
{
    Module.Trigger(ModuleType::tInput, state);
}

//---------------------------------------------------------------------------
//  ModuleIo::SetOutputSoftwareTrigger() --  Set or Clear Software Trigger
//---------------------------------------------------------------------------

void  ModuleIo::SetOutputSoftwareTrigger(bool state)
{
    Module.Trigger(ModuleType::tOutput, state);
}

//---------------------------------------------------------------------------
//  ModuleIo::SetTestConfiguration() --  Configure Test Setup
//---------------------------------------------------------------------------

void  ModuleIo::SetTestConfiguration( bool /*enable*/, int /*mode_idx*/ )
{
}

